
/* Generated by Interface Builder */

#import "Trombone.h"
#import "SpectrumView.h"
#import "BellView.h"
#import "MouthpieceView.h"
#import <Cocoa/Cocoa.h>
#import <math.h>

@implementation Trombone

#define SND_FORMAT_LINEAR_16 0
#define MOUTHPIECE_LENGTH 6
#define BELL_LENGTH 200
#define SLIDE_LENGTH 250
#define LIP_TABLE_LENGTH 1024
#define SRATE 22050
#define SND_RATE_LOW SRATE
#define ONE_OVER_PI 0.318309886
#define XFORM_LENGTH 4096
#define POWER_OF_FOUR 6

double bellCoeffs[BELL_LENGTH+1];
double bellRadii[BELL_LENGTH+1];
double bellDLine1[BELL_LENGTH+1], bellDLine2[BELL_LENGTH+1];
double slideDLine1[SLIDE_LENGTH], slideDLine2[SLIDE_LENGTH];
double lastBellOut=0.0, lastBellRefl=0.0, bellMemory=0.0;
double lastLipOut=0.0, lastLipPos=0.0, lipZ1=0.0, lipZ2=0.0, lipC1, lipC2;
double lipTable[LIP_TABLE_LENGTH];
double mass, sprConstant, damping, deltaT;
double envMax, outGain;
double bellFlare = 1.0;
double lastMPOut;
double mpDLine1[MOUTHPIECE_LENGTH+1];
double mpDLine2[MOUTHPIECE_LENGTH+1];
double mpRadii[MOUTHPIECE_LENGTH+1] = {2.0,1.8,0.4,0.55,0.7,0.85,1.0};
double mpCoeffs[MOUTHPIECE_LENGTH+1];
int totalEnvTime, decayTime,attackTime,currentEnvTime;
double currentEnvValue;
int bell_length, slide_length, slide_delta;
double envOvershoot, attackDelta, decay1Delta, decay2Delta;


- (void)awakeFromNib;
{
    [self changeBell:bellField];
    [self changeMouthpieceFields:mouthpieceFields];
    [self changeLipFields:myLipFields];
}

- (IBAction) sweepMassSpring:sender;
{
    short *data;
		int i,j,dLineLength;
    double tempSlideMinus;
    double massDelta,springDelta,dampDelta,timeDelta;
    if(!mySound)
		{
			mySound  = [Sound alloc];
    }
    [self setMouthPiece];
    [self setLip];
    [self setBell];
    timeDelta = ([lipSweepTil doubleValue] - [lipSweepFrom doubleValue]) * SRATE;
    massDelta = [[lipFinal cellAtIndex: 0] doubleValue] - [[lipInitial cellAtIndex: 0] doubleValue];
    springDelta = [[lipFinal cellAtIndex: 1] doubleValue] - [[lipInitial cellAtIndex: 1] doubleValue];
    dampDelta = [[lipFinal cellAtIndex: 2] doubleValue] - [[lipInitial cellAtIndex: 2] doubleValue];
    dLineLength = [self setSlide];
    massDelta /= timeDelta;
    springDelta /= timeDelta;
    dampDelta /= timeDelta;
    envMax = [envelopeMax doubleValue];
    [self setupEnvelope];
		[mySound	setDataSize:totalEnvTime*2
							dataFormat:SND_FORMAT_LINEAR_16
							samplingRate:SND_RATE_LOW
							channelCount:1
							infoSize:12];
    outGain = [outputGain doubleValue];
    data = (short *) [mySound getData];
    j=0;
		mass = [[lipInitial cellAtIndex: 0] doubleValue];
		sprConstant = [[lipInitial cellAtIndex: 1] doubleValue];
		damping = [[lipInitial cellAtIndex: 2] doubleValue];
		lipC1 = -2.0 + (((sprConstant * deltaT ) + damping) * deltaT / mass);
		lipC2 = 1.0 - (damping * deltaT / mass);
		for (i=0;i<[lipSweepFrom floatValue] * SRATE;i++)
		{
			tempSlideMinus = [self nextBellTick: slideDLine1[j]];
			slideDLine1[j] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[j]];
			slideDLine2[j] = tempSlideMinus;
			data[i] = lastBellOut * outGain;
			if (j<dLineLength) j++; else j=0;
    }
    for (i=[lipSweepFrom floatValue] * SRATE; i<[lipSweepTil floatValue] * SRATE;i++)
		{
			mass += massDelta;
			sprConstant += springDelta;
			damping += dampDelta;
    	lipC1 = -2.0 + (((sprConstant * deltaT ) + damping) * deltaT / mass);
    	lipC2 = 1.0 - (damping * deltaT / mass);
			tempSlideMinus = [self nextBellTick: slideDLine1[j]];
			slideDLine1[j] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[j]];
			slideDLine2[j] = tempSlideMinus;
			data[i] = lastBellOut * outGain;
			if (j<dLineLength) j++; else j=0;
    }
    for (i=[lipSweepTil floatValue] * SRATE;i<totalEnvTime;i++)
		{
			tempSlideMinus = [self nextBellTick: slideDLine1[j]];
			slideDLine1[j] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[j]];
			slideDLine2[j] = tempSlideMinus;
			data[i] = lastBellOut * outGain;
			if (j<dLineLength) j++; else j=0;
    }
    [mySound writeSoundfile: "/tmp/test.snd"];
    [mySound play];
    //return self;
}

- (IBAction) valveTrill:sender;
{
    short *data;
    int i,j,k,m,n,dLineLengthMin,dLineLengthMax,dLineLength,dLineDelta;
    double tempSlideMinus;
    int trillFrom,trillUntil,trillPeriod;
    if (!mySound)
		{
        mySound  = [Sound alloc];
    }
    [self setMouthPiece];
    [self setLip];
    [self setBell];
    [self changeTotalDelay:valveLengths];
    dLineLengthMin = [[slideLengths cellAtRow:1 column:0] intValue];
    dLineLengthMin += ([[slideLengths cellAtRow: 0 column:0] intValue] - dLineLengthMin) * 
												[[mySlide cellAtRow:1 column:0] doubleValue] * 0.142857;
    dLineLengthMax = dLineLengthMin;
    for (j=0;j<4;j++)
		{
			if ([[valveInitial cellAtRow:j column:0] state]) dLineLengthMin += [[valveLengths cellAtRow:j column:0] intValue];
    }
    for (j=0;j<4;j++)	{
        if ([[valveFinal cellAtRow:j column:0] state]) dLineLengthMax += [[valveLengths cellAtRow:j column:0] intValue];
    }
    dLineDelta = abs(dLineLengthMax - dLineLengthMin) + 3;
    envMax = [envelopeMax doubleValue];
    [self setupEnvelope];
		[mySound 	setDataSize:totalEnvTime*2
							dataFormat:SND_FORMAT_LINEAR_16
							samplingRate:SND_RATE_LOW
							channelCount:1
							infoSize:12];
    outGain = [outputGain doubleValue];
    data = (short *) [mySound getData];
    trillFrom = [valveTrillFrom floatValue] * SRATE;
    trillUntil = [valveTrillTil floatValue] * SRATE;
    trillPeriod = SRATE * 0.5 / [trillRate floatValue];
    j=0;
    dLineLength = dLineLengthMin;
    for (i=0;i<trillFrom;i++)	{
	 for (j=dLineLength,m=0;j>0;j--,m++)    {
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[m] = slideDLine2[m+1];
	 }    
	 tempSlideMinus = [self nextBellTick:slideDLine1[dLineLength]];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[0]];
	slideDLine2[dLineLength] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
    }
    k=0;
    for (i=trillFrom;i<trillUntil;i++)	{
	 for (j=dLineLength,m=0;j>0;j--,m++)    {
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[m] = slideDLine2[m+1];
	 }    
	 for (j=dLineLength+1;j<dLineLength+dLineDelta;j++)    {
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[j] = slideDLine2[j-1];
	 }    
	 tempSlideMinus = [self nextBellTick:slideDLine1[dLineLength]];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[0]];
	slideDLine2[dLineLength] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
	k++;
	if (k==trillPeriod)	{
	    if (dLineLengthMax>dLineLengthMin)
	        if (dLineLength==dLineLengthMin) n=1; else n= -1;
	    else if (dLineLength==dLineLengthMin) n= -1; else n= 1;
	    if (dLineLengthMax==dLineLengthMin) k = 0;
	}
	if (k>=trillPeriod) 	    {
	    dLineLength += n;
	    if (dLineLength==dLineLengthMax || dLineLength==dLineLengthMin) k=0;
	}
    }
    for (i=trillUntil;i<totalEnvTime;i++)	{
	 for (j=dLineLength,m=0;j>0;j--,m++)    {
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[m] = slideDLine2[m+1];
	 }    
	 tempSlideMinus = [self nextBellTick:slideDLine1[dLineLength]];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[0]];
	slideDLine2[dLineLength] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
    }
    [mySound writeSoundfile: "/tmp/test.snd"];
    [mySound play];
    //return self;
}

double interp(double sample1,double sample2,double factor)
{
    return sample1 + ((sample2 - sample1) * factor);
}

- (IBAction) sweepSlide:sender;
{
    short *data;
   int i,j,dLineLength;
    int sweepFrom,sweepUntil;
    double doubleDLineLength,deltaDLineLength;
    double tempSlideMinus,deltaTime;
    if (!mySound) {
        mySound  = [Sound alloc];
    }
    [self setMouthPiece];
    [self setLip];
    [self setBell];
    [self setSlide];
    deltaTime = ([slideSweepTil doubleValue] - [slideSweepFrom doubleValue]) * SRATE;
    doubleDLineLength = [slideInitial doubleValue];
    deltaDLineLength = [slideFinal doubleValue] - [slideInitial doubleValue];
    deltaDLineLength /= deltaTime;
    envMax = [envelopeMax doubleValue];
    [self setupEnvelope];
	[mySound setDataSize:totalEnvTime*2
     			dataFormat:SND_FORMAT_LINEAR_16
     			samplingRate:SND_RATE_LOW
     			channelCount:1
     			infoSize:12];
    outGain = [outputGain doubleValue];
    data = (short *) [mySound getData];
    dLineLength = doubleDLineLength + 1;
    sweepFrom = [slideSweepFrom floatValue] * SRATE;
    sweepUntil = [slideSweepTil floatValue] * SRATE;
    for (i=0;i<sweepFrom;i++)    {
	 for (j=dLineLength+2;j>0;j--)	{
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[j] = slideDLine2[j-1];
	 }    
	 tempSlideMinus = [self nextBellTick:slideDLine1[dLineLength]];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[dLineLength]];
	slideDLine2[0] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
    }
    for (i=sweepFrom;i<sweepUntil;i++)    {
         doubleDLineLength += deltaDLineLength;
	 dLineLength = doubleDLineLength+1;
	 for (j=dLineLength+2;j>0;j--)	{
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[j] = slideDLine2[j-1];
	 }    
	 tempSlideMinus = [self nextBellTick: 
	 		interp(slideDLine1[dLineLength],slideDLine1[dLineLength-1],dLineLength-doubleDLineLength)];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] 
		with: interp(slideDLine2[dLineLength],slideDLine2[dLineLength-1],dLineLength-doubleDLineLength)];
	slideDLine2[0] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
    }
    for (i=sweepUntil ;i<totalEnvTime;i++)    {
	 for (j=dLineLength+2;j>0;j--)	{
	     slideDLine1[j] = slideDLine1[j-1];
	     slideDLine2[j] = slideDLine2[j-1];
	 }    
	 tempSlideMinus = [self nextBellTick:slideDLine1[dLineLength]];
	slideDLine1[0] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[dLineLength]];
	slideDLine2[0] = tempSlideMinus;
	data[i] = lastBellOut * outGain;
    }
    [mySound writeSoundfile: "/tmp/test.snd"];
    [mySound play];
    //return self;
}

- (IBAction) toot:sender
{
    short *data;
   int i,j,dLineLength;
    double tempSlideMinus;
    if (!mySound) {
        mySound  = [Sound alloc];
    }
	[mySound setDataSize:SRATE * 2 * 0.4
     			dataFormat:SND_FORMAT_LINEAR_16
     			samplingRate:SND_RATE_LOW
     			channelCount:1
     			infoSize:12];
    [self setMouthPiece];
    [self setLip];
    [self setBell];
    dLineLength = [self setSlide];
    [self tootEnvelope];
    envMax = [envelopeMax doubleValue];
    outGain = [outputGain doubleValue];
    data = (short *) [mySound getData];
		
		//slideDLine1[dLineLength-1 ] = 100000.0;
    for(j=0, i=0;i<SRATE*0.4;i++)	{
			tempSlideMinus = [self nextBellTick: slideDLine1[j]];
			slideDLine1[j] = [self nextLipTick: [self nextEnvelope] with: slideDLine2[j]];
			slideDLine2[j] = tempSlideMinus;
			data[i] = lastBellOut * outGain;
			if (j<dLineLength) j++; else j=0;
    }
    [mySound writeSoundfile: "/tmp/test.snd"];
    [mySound play];
    //return self;
}

- (IBAction) impulse:sender
{
    float floatData[XFORM_LENGTH];
   int i,j,dLineLength;
    double tempSlideMinus;
    [self setMouthPiece];
    [self setLip];
    [self setBell];
    dLineLength = [self setSlide];
    slideDLine1[dLineLength/2 ] = 1.0;
    for (i=0, j=0;i<XFORM_LENGTH;i++)
		{
			tempSlideMinus = [self nextBellTick: slideDLine1[j]];
			slideDLine1[j] = [self nextLipTick: 0.0 with: slideDLine2[j]];
			slideDLine2[j] = tempSlideMinus;
			floatData[i] = lastBellOut * (XFORM_LENGTH - i);
			if (j<dLineLength) j++; else j=0;
    }
    [boreSpectView fhtRX4: POWER_OF_FOUR array: floatData];
    [boreSpectView logMag: XFORM_LENGTH array: floatData floor: -100.0];
    
    for(i=1, j=0;i<2048&&j<10;i++)
		{
			if(floatData[i-1]<floatData[i] && floatData[i+1]<=floatData[i] && floatData[i]>0.0)
			{
				if (j<5) [[modes cellAtRow:j column:0] setDoubleValue: (double) i / XFORM_LENGTH * SRATE];
				else [[modes cellAtRow:j - 5 column:1] setDoubleValue: (double) i / XFORM_LENGTH * SRATE];
				j++;
			}
    }
		[boreSpectView drawSpectrum: (XFORM_LENGTH / 16) array: floatData];
    //return self;
}

- (IBAction) playSound:sender
{
    [mySound play];
    //return self;
}

- (IBAction) changeTotalDelay:sender
{
    if (![boreSpectTrack state]) [self impulse:nil];
    //return self;
}

- (IBAction) changeSlide:sender
{
    double temp;
    temp = [[sender selectedCell] doubleValue];
    [[sender cellAtRow:0 column:0] setDoubleValue: temp];
    [[sender cellAtRow:1 column:0] setDoubleValue: temp];
    [self changeTotalDelay:sender];
    //return self;
}

- (IBAction) changeBell:sender
{
    bell_length = [bellLength intValue];
    if ([sender intValue] != bell_length)	{
        bellFlare = [sender doubleValue];
        [bellPot setDoubleValue: bellFlare];
        [bellField setDoubleValue: bellFlare];
    }
    [self setBell];
    [bellView drawBell: bell_length  array: bellRadii];
    if (![boreSpectTrack state]) [self impulse:nil];
    //return self;
}

- (IBAction) changeLipPots:sender
{
    int i;
    for (i=0;i<3;i++)  [[myLipFields cellAtRow:i column:0] setDoubleValue: 
    				[[myLipPots cellAtRow:0 column:i] doubleValue]];
		[self setMouthPiece];
    [self setLip];
    //return self;
}

- (IBAction) changeLipFields:sender
{
    int i;
    for (i=0;i<3;i++)  [[myLipPots cellAtRow:0 column:i] setDoubleValue: 
    				[[myLipFields cellAtRow:i column:0] doubleValue]];
    [self setMouthPiece];
    [self setLip];
    //return self;
}

- (IBAction) changeMouthpiecePots:sender
{
    int i;
    for (i=0;i<MOUTHPIECE_LENGTH;i++)
		{
        mpRadii[i] = [[mouthpiecePots cellAtRow:0 column:i] doubleValue];
				[[mouthpieceFields cellAtRow:0 column:i] setDoubleValue: mpRadii[i]];
    }
    mpRadii[MOUTHPIECE_LENGTH] = 1.0;
    [self setMouthPiece];
    [self setLip];
    [mouthpieceView drawMouthpiece: MOUTHPIECE_LENGTH array: mpRadii];
    if (![boreSpectTrack state]) [self impulse:nil];
    //return self;
}

- (IBAction) changeMouthpieceFields:sender
{
    int i;
    for (i=0;i<MOUTHPIECE_LENGTH;i++)  {
        mpRadii[i] = [[mouthpieceFields cellAtRow:0 column:i] doubleValue];
	[[mouthpiecePots cellAtRow:0 column:i] setDoubleValue: mpRadii[i]];
    }
    mpRadii[MOUTHPIECE_LENGTH] = 1.0;
    [self setMouthPiece];
    [self setLip];
    [mouthpieceView drawMouthpiece: MOUTHPIECE_LENGTH array: mpRadii];
    if (![boreSpectTrack state]) [self impulse:nil];
    //return self;
}

- (int) setSlide
{
    int j;
    slide_length = [[slideLengths cellAtRow:1 column:0] intValue];
    for (j=0;j<4;j++)	{
        if ([[valvePositions cellAtRow:0 column:j] state]) slide_length += [[valveLengths cellAtRow:j column:0] intValue];
    }
    slide_delta = [[slideLengths cellAtRow:0 column:0] intValue] - slide_length;
    for (j=0;j<SLIDE_LENGTH;j++)	{
	slideDLine1[j] = 0.0;
	slideDLine2[j] = 0.0;	
    }
    return slide_length +  ([[mySlide cellAtRow:1 column:0] doubleValue] * 0.142857 * slide_delta + 1);
}

- (IBAction) setLip
{
    int i;
    double temp;
    float impulse[1024];
    deltaT = 1.0 / (double) SRATE;
    mass = [[myLipFields cellAtRow:0 column:0] doubleValue];
    sprConstant = [[myLipFields cellAtRow:1 column:0] doubleValue];
    damping = [[myLipFields cellAtRow:2 column:0] doubleValue];
    lipC1 = -2.0 + (((sprConstant * deltaT ) + damping) * deltaT / mass);
    lipC2 = 1.0 - (damping * deltaT / mass);
    temp = -lipC1  / 2.0 / sqrt(lipC2);
    [centerFreq setDoubleValue: acos(temp) * 0.5 * SRATE * ONE_OVER_PI];
    lipZ1 = 0.0;
    lipZ2 = 1.0;
    lastLipPos = 0.0;
    for (i=0;i<1024;i++)
		{ 
			lastLipPos = -(lipC1 * lipZ1) - (lipC2 * lipZ2);
			lipZ2 = lipZ1;
			lipZ1 = lastLipPos;
			impulse[i] = lastLipPos;
    }
    [lipSpectView fhtRX4: 5 array: impulse];
    [lipSpectView logMag: 1024 array: impulse floor: -100.0];
    [lipSpectView drawSpectrum: 64 array: impulse];
    lipZ1 = 0;
    lipZ2 = 0;
    lastLipOut = 0;
    lastLipPos = 0;
    if (lipTable[0]!=1.0) for (i=0;i<LIP_TABLE_LENGTH;i++) 
        lipTable[i] = (double) (LIP_TABLE_LENGTH - i) / (double) LIP_TABLE_LENGTH;
    //return self;    
}

- (IBAction) setMouthPiece
{
    int j;
    double t[MOUTHPIECE_LENGTH+1];
    t[0]=mpRadii[0] * mpRadii[0];
    mpDLine1[0] = 0.0;
    mpDLine2[0] = 0.0;	
    for (j=0;j<MOUTHPIECE_LENGTH;j++) 
		{
			mpDLine1[j] = 0.0;
			mpDLine2[j] = 0.0;	
    	t[j]=mpRadii[j] * mpRadii[j];
			if (t[j]==0) t[j]=1e-10;
    }
    for (j=1;j<MOUTHPIECE_LENGTH;j++)	{
	mpCoeffs[j]=(t[j-1]-t[j]) / (t[j-1]+t[j]);
    }
    mpCoeffs[MOUTHPIECE_LENGTH] = 0.0;
    lastMPOut = 0.0;
    //return self;    
}

- (IBAction) setBell
{
    int j;
    double t[BELL_LENGTH+1];
    t[0]=1.0;
    for (j=0;j<bell_length;j++)	{
        bellRadii[j] = pow(bellFlare,(double) j);
	bellDLine1[j] = 0.0;
	bellDLine2[j] = 0.0;	
    }
    for (j=1;j<bell_length;j++)   {
    	t[j]=bellRadii[j-1] * bellRadii[j-1];
	if (t[j]==0) t[j]=1e-10;
    }
    for (j=1;j<bell_length;j++)	{
	bellCoeffs[j]=(t[j-1]-t[j]) / (t[j-1]+t[j]);
    }
    for (j=0;j<SLIDE_LENGTH;j++)	{
	slideDLine1[j] = 0.0;
	slideDLine2[j] = 0.0;	
    }
    lastBellOut = 0.0;
    lastBellRefl = 0.0;
    bellMemory = 0.0;
    //return self;
}

- (IBAction) tootEnvelope
{
     totalEnvTime = 0.4 * 22050;
     decayTime = 0.1 * 22050;
     attackTime = 0.1 * 22050;
     envOvershoot = 1.2;     
     attackDelta =  envOvershoot / attackTime;
     decay1Delta = (envOvershoot - 1.0) / decayTime;
     decay2Delta = 1.0 / decayTime;
     currentEnvTime = 0;
     currentEnvValue = 0.0;
     //return self;
}

- (IBAction) setupEnvelope
{
     totalEnvTime = [[envelope cellAtRow:2 column:0] doubleValue] * 22050.0;
     decayTime = [[envelope cellAtRow:1 column:0] doubleValue] * 22050.0;
     if (decayTime <=0) decayTime = 1;
     attackTime = [[envelope cellAtRow:0 column:0] doubleValue] * 22050.0;
     if (attackTime <=0) attackTime = 1;
     envOvershoot = [[envelope cellAtRow:3 column:0] doubleValue];     
     attackDelta =  envOvershoot / attackTime;
     decay1Delta = (envOvershoot - 1.0) / decayTime;
     decay2Delta = 1.0 / decayTime;
     currentEnvTime = 0;
     currentEnvValue = 0.0;
     //return self;
}

- (double) nextEnvelope
{
    if (currentEnvTime<attackTime) currentEnvValue +=  attackDelta;
    if (currentEnvTime>=attackTime && currentEnvTime<2*attackTime) 
    	currentEnvValue -= decay1Delta;
    if (currentEnvTime>totalEnvTime - decayTime) currentEnvValue -=  decay2Delta;
    currentEnvTime += 1;
    return envMax * currentEnvValue;
}

- (double) nextBellTick: (double) inputSample
{
    int j;
    double t1,temp;

    bellDLine2[1] = bellDLine2[2] + bellCoeffs[1] * (inputSample - bellDLine2[2]);
    temp = inputSample + bellDLine2[1] - bellDLine2[2];
    for (j=2;j<bell_length-1;j++)  {
	    bellDLine2[j] = bellDLine2[j+1] + bellCoeffs[j] * (bellDLine1[j-1] - bellDLine2[j+1]);
	    t1 = temp; 
	    temp = bellDLine1[j-1] + bellDLine2[j] - bellDLine2[j+1];
	    bellDLine1[j-1] = t1;
    }
    bellDLine2[bell_length-1] = lastBellRefl + bellCoeffs[bell_length-1] * 
    			(bellDLine1[bell_length-2] - lastBellRefl);
    bellDLine1[bell_length-1] = bellDLine1[bell_length-2] + bellDLine2[bell_length-1]
    						- lastBellRefl;
    bellDLine1[bell_length-2] = temp;
    lastBellOut = bellDLine1[bell_length-1] - (0.5 * bellMemory);
    lastBellRefl = (bellDLine1[bell_length-1] + bellMemory) * -0.3;
    bellMemory = bellDLine1[bell_length-1];
    return bellDLine2[1];
}

- (double) nextLipTick: (double) inputSample with: (double) boreSample
{
    int j;
    double t1,temp;
    lastLipPos = ((inputSample - mpDLine2[1]) * deltaT * deltaT / mass) - lipC1 * lipZ1 - lipC2 * lipZ2;
    if (lastLipPos<0.0) lastLipPos = 0.0;
    lipZ2 = lipZ1;
    lipZ1 = lastLipPos;
    if (lastLipPos<LIP_TABLE_LENGTH)	{
        lastLipOut = lipTable[(int)lastLipPos] * mpDLine2[1] + 
			(1.0-lipTable[(int)lastLipPos]) * inputSample;
//	printf("%f , ",lastLipPos);
    }
    else		{
        lastLipOut = inputSample;
//	printf("%f   ",lastLipPos);
    }

    lastMPOut = mpDLine1[MOUTHPIECE_LENGTH-1];
    mpDLine2[1] = mpDLine2[2] + mpCoeffs[0] * (lastLipOut - mpDLine2[2]);
    temp = lastLipOut + mpDLine2[1] - mpDLine2[2];
    for (j=2;j<MOUTHPIECE_LENGTH-1;j++)  {
	    mpDLine2[j] = mpDLine2[j+1] + 
	    		mpCoeffs[j-1] * (mpDLine1[j-1] - mpDLine2[j+1]);
	    t1 = temp; 
	    temp = mpDLine1[j-1] + mpDLine2[j] - mpDLine2[j+1];
	    mpDLine1[j-1] = t1;
    }
    mpDLine2[MOUTHPIECE_LENGTH-1] = boreSample + mpCoeffs[MOUTHPIECE_LENGTH-2] * 
    			(mpDLine1[MOUTHPIECE_LENGTH-2] - boreSample);
    mpDLine1[MOUTHPIECE_LENGTH-1] = mpDLine1[MOUTHPIECE_LENGTH-2] + 
    			mpDLine2[MOUTHPIECE_LENGTH-1] - boreSample;
    mpDLine1[MOUTHPIECE_LENGTH-2] = temp;
    return lastMPOut;
}

@end
